<html lang="en">
<head>
<title>Semantic Components - Semantic Manual</title>
<meta http-equiv="Content-Type" content="text/html">
<meta name="description" content="Semantic Manual">
<meta name="generator" content="makeinfo 4.8">
<link title="Top" rel="start" href="index.html#Top">
<link rel="up" href="Overview.html#Overview" title="Overview">
<link href="http://www.gnu.org/software/texinfo/" rel="generator-home" title="Texinfo Homepage">
<!--
This manual documents Semantic, a new intrastructure for parser
based text analysis for Emacs.

Copyright (C) 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2007 Eric M. Ludlam
Copyright (C) 2001, 2002, 2003, 2005 David Ponce
Copyright (C) 2002, 2003 Richard Y. Kim

     Permission is granted to copy, distribute and/or modify this
     document under the terms of the GNU Free Documentation License,
     Version 1.1 or any later version published by the Free Software
     Foundation; with the Invariant Sections being list their titles,
     with the Front-Cover Texts being list, and with the Back-Cover
     Texts being list.  A copy of the license is included in the
     section entitled ``GNU Free Documentation License''.
-->
<meta http-equiv="Content-Style-Type" content="text/css">
<style type="text/css"><!--
  pre.display { font-family:inherit }
  pre.format  { font-family:inherit }
  pre.smalldisplay { font-family:inherit; font-size:smaller }
  pre.smallformat  { font-family:inherit; font-size:smaller }
  pre.smallexample { font-size:smaller }
  pre.smalllisp    { font-size:smaller }
  span.sc    { font-variant:small-caps }
  span.roman { font-family:serif; font-weight:normal; } 
  span.sansserif { font-family:sans-serif; font-weight:normal; } 
--></style>
</head>
<body>
<div class="node">
<p>
<a name="Semantic-Components"></a>
Up:&nbsp;<a rel="up" accesskey="u" href="Overview.html#Overview">Overview</a>
<hr>
</div>

<h3 class="section">1.1 Semantic Components</h3>

<p>This chapter gives an overview of major components of <i>semantic</i> and
how they interact with each other to perform its job.

<p>The first step of parsing is to break up the input file into its
fundamental components.  This step is called lexical analysis.  The
output of the lexical analyzer is a list of tokens that make up the
file.

<pre class="example">             syntax table, keywords list, and options
                              |
                              |
                              v
         input file  ----&gt;  Lexer   ----&gt; token stream
</pre>
<p>The next step is the parsing shown below.

<pre class="example">                         parser tables
                              |
                              v
         token stream ---&gt;  Parser  ----&gt; parse tree
</pre>
<p>The end result, the parse tree, is created based on the parser tables,
which are in the internal representation of the language grammar used by
<i>semantic</i>.

<p>The <i>semantic</i> database provides caching of the parse trees by saving them
into files named <samp><span class="file">semantic.cache</span></samp> automatically when loading them
when appropriate instead of re-parsing.  The reason for this is to save the
time it takes to parse a file which could take several seconds or more
for large files.

<p>Finally, <i>semantic</i> provides an <acronym>API</acronym> for the Emacs Lisp
programmer to access the information in the parse tree.

<!-- LocalWords:  API LALR -->
</body></html>

